-- gategen.vhdl
-- creates : jeu. août  8 10:18:01 CEST 2019  by Yann Guidon (whygee@f-cpu.org)
-- Released under the GNU AGPLv3 license

Library ieee;
    use ieee.std_logic_1164.all;
    use ieee.numeric_std.all;
Library work;
    use work.all;
    use work.PA3gategen.all;
use STD.textio.all;

entity GateGen is
end GateGen;

architecture runme of GateGen is
  file gate_defs : text open write_mode is "PA3_definitions.vhdl";
  file gate_list : text open write_mode is "PA3_components.vhdl";
begin

  bench: process
    variable i: integer := 0;
    variable t : EnumGates3;
    variable L8 : LookupType8;
    variable L4 : LookupType4;
    variable op : character;
    variable row : line;    

    procedure wl(s: string) is
    begin
      write(row, s);
      writeline(gate_list, row);
    end wl;

    procedure wd(s: string) is
    begin
      write(row, s);
      writeline(gate_defs, row);
    end wd;

  begin

    wl("-- File : PA3_components.vhdl");
    wl("-- DO NOT MODIFY ! Generated file !");
    wl("-- (C) Yann Guidon 20190808");
    wl("");
    wl("Library ieee;");
    wl("    use ieee.std_logic_1164.all;");
    wl("");
    wl("package proasic3 is");

    wd("-- File : PA3_definitions.vhdl");
    wd("-- DO NOT MODIFY ! Generated file !");
    wd("-- (C) Yann Guidon 20190808");
    wd("");

    wl("");
    wl("  component register_generics port("
       & " gate_select_number: in integer; "
       &  " bit_select_number: in integer; "
       & " gate_select_string: in string); end component;"); 
    wl("");

    wd("");
    wd("Library ieee;");
    wd("    use ieee.std_logic_1164.all;");
    wd("Library work;");
    wd("    use work.all;");
    wd("    use work.PA3gategen.all;");
    wd("");
    wd("entity register_generics is");
    wd("  port( gate_select_number: in integer;");
    wd("         bit_select_number: in integer);");
    wd("end register_generics;");
    wd("");
    wd("architecture rtl of register_generics is");
    wd("begin");
    wd("  update_select_gate(gate_select_number,"
        & " bit_select_number);"); -- called only once at start
    wd("end rtl;");
    wd("");
    wd("--------------------------------------------------");
    wd("");

    wl("");
    wl("-- 2-inputs gates :");

    for t in EnumGates2 loop
      L4 := ComputeLUT4(t);
      write(row, "  component " & EnumGates2'image(t), left, 19);
      wl(" port(A, B : in std_logic; Y : out std_logic); end component; -- " & SLV_to_bin(L4));

      wd("");
      wd("Library ieee;");
      wd("    use ieee.std_logic_1164.all;");
      wd("Library work;");
      wd("    use work.all;");
      wd("    use work.PA3gategen.all;");
      wd("");
      wd("entity " & EnumGates2'image(t) & " is");
      wd("  port( A, B : in std_logic;");
      wd("           Y : out std_logic);");
      wd("end " & EnumGates2'image(t) & ";");
      wd("");
      wd("architecture rtl of " & EnumGates2'image(t) & " is");
      wd("  signal LUT4 : LookupType4 := """ & SLV_to_bin(L4) & """;");
      wd("begin");
      wd("  LUT4 <= InferLUT4(LUT4, LUT4'instance_name);");     -- called only once at start
      wd("  Y <= LookItUp2(A, B, LUT4); -- after gate_delay;");
      wd("end rtl;");
      wd("");
      wd("--------------------------------------------------");
      wd("");

    end loop;


    wl("");
    wl("-- 3-inputs gates :");
    for t in EnumGates3 loop
      case t is
        when MX2    =>  op := 'S';
        when MX2A   =>  op := 'S';
        when MX2B   =>  op := 'S';
        when MX2C   =>  op := 'S';
        when others =>  op := 'C';
      end case;

      L8 := ComputeLUT8(t);
      write(row, "  component " & EnumGates3'image(t), left, 19);
      wl(" port(A, B, " & op
          & " : in std_logic; Y : out std_logic); end component; -- " & SLV_to_bin(L8));

      wd("");
      wd("Library ieee;");
      wd("    use ieee.std_logic_1164.all;");
      wd("Library work;");
      wd("    use work.all;");
      wd("    use work.PA3gategen.all;");
      wd("");
      wd("entity " & EnumGates3'image(t) & " is");
      wd("  port( A, B, " & op &" : in std_logic;");
      wd("              Y : out std_logic);");
      wd("end " & EnumGates3'image(t) & ";");
      wd("");
      wd("architecture rtl of " & EnumGates3'image(t) & " is");
      wd("  signal LUT8 : LookupType8 := """ & SLV_to_bin(L8) & """;");
      wd("begin");
      wd("  LUT8 <= InferLUT8(LUT8, LUT8'instance_name);");    -- called only once at start
      wd("  Y <= LookItUp3(A, B, " & op &", LUT8); -- after gate_delay;");
      wd("end rtl;");
      wd("");
      wd("--------------------------------------------------");
      wd("");

    end loop;

    wl("");
    wl("end proasic3;");

    wait;
  end process;

end runme;
