-- test_name.vhdl
-- created ven. août  9 03:14:28 CEST 2019

Library ieee;
    use ieee.std_logic_1164.all;
Library proasic3;
    use proasic3.all;

entity test_name is
  generic (
    gate_select_number: integer := 0;
    bit_select_number: integer := -1
  );
end test_name;

architecture rtl of test_name is
  signal A, B, C, D, E, F, Y : std_logic;
begin
  -- this entity MUST be written first,
  -- at the very beginning of the toplevel file:
  rg: entity register_generics port map(
       gate_select_number => gate_select_number,
       bit_select_number => bit_select_number);

  x1: entity xor2  port map(A => A, B=>B,  Y=>E );
  x2: entity xor2  port map(A => C, B=>E,  Y=>F );
  x3: entity xor2  port map(A => D, B=>F,  Y=>Y );

  test: process
  begin
    wait for 100 ns;

    A <= '0';
    loop

      B <= '0';
      loop

	C <= '0';
        loop

          D <= '0';
          loop

            wait for 1 ns;
            report  " A=" & std_logic'image(A) &
                    " B=" & std_logic'image(B) &
                    " C=" & std_logic'image(C) &
                    " D=" & std_logic'image(D) &
                    " E=" & std_logic'image(E) &
                    " F=" & std_logic'image(E) &
                    " Y=" & std_logic'image(Y);

            exit when D = '1';
            D <= '1';
          end loop;

          exit when C = '1';
          C <= '1';
        end loop;

        exit when B = '1';
        B <= '1';
      end loop;

      exit when A = '1';
      A <= '1';
    end loop;

    wait;
  end process;

end rtl;
